#
# coursebuilder
#

from argparse import ArgumentParser
from pathlib import Path
import yaml

class Course:
    def 


class StudyCourse:
    def __init__(self, data: dict | None, path: Path | None):
        self.path: Path | None = path
        self.data: dict | None = data

        courses: list[Course] = []

    @staticmethod
    def load(*, path: str):
        with open(path) as f:
            data = yaml.load(f, Loader=yaml.Loader)
            return StudyCourse(data=data, path=Path(path))

    def __str__(self):
        return f"path: {self.path}\ndata: {self.data}"


def main():
    # parser
    parser = ArgumentParser(description="versatile curricula generator")

    # loading mode for internal database
    parser.add_argument(
        "-i",
        "--input",
        type=str,
        help="folder with project data",
    )

    # get arguments
    args = parser.parse_args()

    # just input
    if args.input:
        sc = StudyCourse.load(path=(Path(".") / args.input).absolute())
        print(sc)


# run as main
if __name__ == "__main__":
    main()
